(*********************************************************************
    MxTool.pas
     -- Process PComm function return value


    History:   Date       Author         Comment
               3/9/98     Casper         Wrote it.
               12/08/98   Casper         Modify message

**********************************************************************)
unit MxTool;

interface

procedure ShowSysErr(const title:String);
procedure MxShowError(const title:String; errcode:LongInt);

implementation

uses  Windows,Dialogs,PComm,SysUtils,Forms;

procedure MxShowError(const title:String;errcode:LongInt);
var
  buf: string;
begin
  if errcode <> SIO_WIN32FAIL then
  begin
    case errcode of
    SIO_BADPORT:
      buf := 'Port number is invalid or port is not opened in advance'#0;
    SIO_OUTCONTROL:
      buf := 'This board does not support this function'#0;
    SIO_NODATA:
      buf := 'No data to read';
    SIO_OPENFAIL:
      //buf := 'No such port or port is occupied by other program'#0;
      buf := 'Com-        !'#0;
    SIO_RTS_BY_HW:
      buf := 'RTS can''t be set because H/W flowctrl'#0;
    SIO_BADPARM:
      buf := 'Bad parameter'#0;
    SIO_BOARDNOTSUPPORT:
      buf := 'This board does not support this function'#0;
    SIO_ABORT_WRITE:
      buf := 'Write has blocked, and user abort write'#0;
    SIO_WRITETIMEOUT:
      buf := 'Write timeout has happened'#0;
    else
      buf := 'Unknown Error:'+IntToStr(errcode)+#0;
    end;
    Application.MessageBox(PChar(@buf[1]), PChar(@title[1]) ,MB_OK or MB_ICONSTOP);
  end
  else
    ShowSysErr(title);
  end;

procedure ShowSysErr(const title:String);
var
  syserr  :LongInt;
  lpMsgBuf:array[0..79] of Char;
  lang    :LongInt;
begin
  syserr := GetLastError();

  {MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT) }
  lang := (SUBLANG_DEFAULT shl 10)  + LANG_NEUTRAL;

  FormatMessage(
                FORMAT_MESSAGE_FROM_SYSTEM,
		nil,
		syserr,
		lang,
		@lpMsgBuf,
		80,
		nil
  );
  Application.MessageBox(lpMsgBuf,PChar(title[1]),MB_OK or MB_ICONSTOP);
end;

end.

